﻿Imports System.IO
Imports System.IO.Compression

Public Module modGZip

    Public Sub Zip(ByVal src As String, ByVal dest As String)
        ' Durch Zwischenschalten des GZipStreams wird aus einem Kopier-Vorgang 
        '  eine GZip-Konvertierung (die komprimierte Datei ist nicht 
        '  Zip-kompatibel)

        Using readStream As New FileStream(src, FileMode.Open), _
            writeStream As New FileStream(dest, FileMode.Create), _
            zipper As New GZipStream(writeStream, CompressionMode.Compress)

            ' (Puffer zum Testen absurd klein gewählt)
            Dim bufSize As Integer = Byte.MaxValue
            Dim buf(bufSize - 1) As Byte

            ' Standard-Kopier-Schleife für Streams mit festgelegtem Ende
            Do
                bufSize = readStream.Read(buf, 0, bufSize)
                zipper.Write(buf, 0, bufSize)
                ' Schleife endet, wenn Puffer nicht ganz befüllt wurde
            Loop Until bufSize < buf.Length
        End Using
    End Sub

    Public Sub UnZip(ByVal src As String, ByVal dest As String)
        ' Rück-Konvertierung. Beachte, daß hier der GZipStream auf dem Read-
        ' Stream  aufsitzt, und mit CompressionMode.Decompress erstellt ist.
        Using readStream As New FileStream(src, FileMode.Open), _
            unZipper As New GZipStream(readStream, _
                CompressionMode.Decompress), _
            writeStream As New FileStream(dest, FileMode.Create)

            ' Verwendung der in die Extension-Methode ausgelagerten Kopier-
            '  Schleife
            unZipper.WriteTo(writeStream)
        End Using
    End Sub

End Module
